# -*- coding: utf-8 -*-
import os
import time

if os.getuid() != 0:
    print("Operation not permitted!")
    print("Use SuperUser to run the script!")
    exit(-1)

print("\n\n\n")

baseAmeyoPackageList = ["", "lvm2","grub2-common","grub2","setup","openssh-server","basesystem","lshw","ncurses-base","audit","tzdata","kernel","glibc-common","irqbalance","nspr","rsyslog","libstdc++","biosdevname","bash","dracut-config-rescue","pcre","sg3_utils","zlib","man-db","xz-libs","sudo","libuuid","xfsprogs","bzip2-libs","kernel-tools","chkconfig","iwl2030-firmware","readline","iwl7260-firmware","gawk","iwl4965-firmware","libattr","iwl135-firmware","libcap","ivtv-firmware","audit-libs","iwl6000-firmware","libffi","iwl6000g2b-firmware","libxml2","iwl6000g2a-firmware","expat","iwl1000-firmware","lua","which","libnl3","file","libaio","nss-softokn","libassuan","e2fsprogs-libs","libgomp","libidn","jansson","sysvinit-tools","tcp_wrappers-libs","gdbm","ethtool","pciutils-libs","newt","iptables","less","device-mapper-persistent-data","ipset","vim-minimal","bc","pinentry","kmod-libs","libpng","libselinux-utils","ncurses","gmp","kernel-tools-libs","libverto","libsemanage","p11-kit-trust","coreutils","openssl-libs","python-libs","shadow-utils","cracklib","libmount","shared-mime-info","cracklib-dicts","pam","gettext-libs","pkgconfig","gobject-introspection","libutempter","pyliblzma","python-schedutils","python-configobj","libselinux-python","pyxattr","mariadb-libs","openssl","fipscheck","nss-pem","nss-sysinit","libcurl","rpm-libs","openldap","python-pycurl","binutils","alsa-lib","hardlink","libdaemon","dmidecode","libestr","libseccomp","json-c","libsmartcols","device-mapper","util-linux","cryptsetup-libs","kmod","systemd-libs","systemd","elfutils-default-yama-scope","polkit-pkla-compat","initscripts","device-mapper-event-libs","policycoreutils","os-prober","cronie-anacron","crontabs","NetworkManager-libnm","dhcp-common","dracut-network","grub2-pc","libdrm","device-mapper-event","wpa_supplicant","ebtables","alsa-firmware","teamd","dbus-python","python-firewall","plymouth-scripts","python-pyudev","pth","rpm-build-libs","gpgme","yum-plugin-fastestmirror","kbd-misc","firewalld","tuned","NetworkManager-tui","libgcc","selinux-policy-targeted","centos-release","kexec-tools","filesystem","openssh-clients","grub2-pc-modules","authconfig","kbd-legacy","postfix","nss-softokn-freebl","chrony","glibc","qemu-guest-agent","nss-util","microcode_ctl","ncurses-libs","aic94xx-firmware","libsepol","parted","libselinux","iprutils","info","passwd","libcom_err","btrfs-progs","sed","e2fsprogs","popt","libsysfs","libdb","iwl105-firmware","grep","rootfiles","elfutils-libelf","iwl5000-firmware","libacl","iwl6050-firmware","libcap-ng","iwl3945-firmware","libgpg-error","iwl3160-firmware","libgcrypt","iwl100-firmware","cpio","iwl5150-firmware","sqlite","iwl2000-firmware","findutils","diffutils","file-libs","libmnl","libnl3-cli","p11-kit","groff-base","xz","libunistring","libedit","libnfnetlink","hostname","lzo","lz4","keyutils-libs","slang","libnetfilter_conntrack","iproute","libteam","ipset-libs","acl","tar","libdb-utils","libss","make","freetype","linux-firmware","mozjs17","snappy","libndp","ustr","libtasn1","ca-certificates","krb5-libs","libblkid","python","gzip","python-decorator","glib2","libcroco","libpwquality","cyrus-sasl-lib","gettext","yum-metadata-parser","python-gobject-base","python-iniparse","newt-python","python-perf","python-linux-procfs","python-slip","grubby","bind-export-libs","libssh2","fipscheck-lib","nss","nss-tools","curl","rpm","libuser","python-urlgrabber","centos-logos","logrotate","libfastjson","qrencode-libs","libpipeline","lsscsi","numactl-libs","sg3_utils-libs","procps-ng","kpartx","device-mapper-libs","dracut","elfutils-libs","dbus-libs","dbus","polkit","iputils","systemd-sysv","grub2-tools-minimal","hwdata","grub2-tools","cronie","dhcp-libs","openssh","dhclient","grub2-tools-extra","libpciaccess","selinux-policy","lvm2-libs","NetworkManager","fxload","alsa-tools-firmware","dbus-glib","python-slip-dbus","plymouth-core-libs","plymouth","virt-what","gnupg2","rpm-python","pygpgme","yum","firewalld-filesystem","kbd","NetworkManager-team"]

os.system("rpm -qa --qf '%{NAME},' > /tmp/pkgFile")
packageFile = open("/tmp/pkgFile", "r")
packagesInstalled = packageFile.read()
packagesInstalledList = packagesInstalled.split(",")

remove = False

command = "yum -y remove"

for package in packagesInstalledList:
    if package not in baseAmeyoPackageList:
        remove = True
        command = command + " " + package

if remove:
    print(command)
    time.sleep(10)
    os.system(command)
else:
    print("No package removal is required")

os.system("yum -y install epel-release yum-utils")
os.system("yum -y install rpmconf")
os.system("rpmconf -a")
os.system("yum -y remove libsysfs-2.1.0-16.el7.x86_64")
os.system("package-cleanup --leaves")
os.system("package-cleanup --orphans")
os.system("yum -y install dnf")
os.system("dnf -y remove yum yum-metadata-parser")
os.system("rm -Rvf /etc/yum")
os.system("rm -rvf /etc/yum/protected.d")
os.system("rm -rvf /etc/yum/vars")
os.system("dnf makecache")
os.system("dnf -y upgrade")
os.system("dnf -y install http://mirror.centos.org/centos/8/BaseOS/x86_64/os/Packages/{centos-linux-repos-8-2.el8.noarch.rpm,centos-linux-release-8.4-1.2105.el8.noarch.rpm,centos-gpg-keys-8-2.el8.noarch.rpm}")
os.system("dnf -y install http://mirror.centos.org/centos/8/BaseOS/x86_64/os/Packages/{centos-linux-repos-8-2.el8.noarch.rpm,centos-linux-release-8.4-1.2105.el8.noarch.rpm,centos-gpg-keys-8-2.el8.noarch.rpm}")
os.system("dnf -y upgrade https://dl.fedoraproject.org/pub/epel/epel-release-latest-8.noarch.rpm")
os.system("rpm -ev `rpm -q kernel`")
os.system("rpm -ev --nodeps sysvinit-tools")
os.system("dnf -y remove iprutils-2.4.17.1-3.el7_7.x86_64 initscripts-9.49.53-1.el7_9.1.x86_64 python36-rpmconf-1.0.22-1.el7.noarch")
os.system("dnf -y --releasever=8 --allowerasing --setopt=deltarpm=false distro-sync")
os.system("dnf -y install kernel-core")
os.system("rm -rf /etc/yum/protected.d")
os.system("rm -rf /etc/yum/vars")
os.system("dnf -y groupupdate \"Core\" \"Minimal Install\"")
os.system("rm -rf /etc/yum/protected.d")
os.system("rm -rf /etc/yum/vars")
os.system("dnf -y install yum")
os.system("curl -O https://raw.githubusercontent.com/oracle/centos2ol/main/centos2ol.sh")
os.system("bash centos2ol.sh")
os.system("grub2-mkconfig –o /boot/grub2/grub.cfg")
os.system("yum -y remove openssh*")
os.system("yum -y install openssh*")
os.system("systemctl enable --now sshd")
